import java.io.*;
import java.security.*;

public class Txt2Ptc {
	private static final String wideTxt = "@ABCDEFGHJKLMNOP~QRSTUVW@Ihfij{C|D^OPQRSTUVWXFGH`abcdefghijklmnopqrstuvwxymnOQMoUp`_\BuvAE@BDFHb[ACEGIJLNPRTVXZ\^`cegijklmnqtwz}~JKXYZ[\]^_`pqrstuvwxyz{|}";
	private static final String voiceConsonantKana = "KMOQSUWY[]_adfhorux{psvy|";
	private static final String voiceConsonantKanaTxt = "JJLJNJPJRJTJVJXJZJ\J^J`JcJeJgJnJqJtJwJzJnKqKtKwKzKEJ";
	private static final String hiragana = "ĂƂȂɂʂ˂̂͂Ђӂւق܂݂ނ߂񂪂Âłǂ΂тԂׂڂς҂Ղ؂ۂ";
	private static final String katakana = "ACEGIJLNPRTVXZ\^`cegijklmnqtwz}~KMOQSUWY[]_adfhorux{psvy|@BDFHb";
	private static final String ascii = " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~";
	public static void main(String args[]){
		File f = null;
		File outFile = null;
		InputStream is = null;
		InputStreamReader isr = null;
		BufferedReader br = null;
		ByteArrayOutputStream baos = null;
		BufferedOutputStream bos = null;
		FileOutputStream fos = null;
		int p = 0;
		if (args.length < 2) {
			System.err.println("̓t@CƏo̓t@Cw肵ĂB");
		}
		try {
			f = new File(args[p++]);
			outFile = new File(args[p++]);
			String pfname;
			if (args.length == 3) {
				pfname = args[p++];
			} else {
				pfname = outFile.getName();
				int cp = pfname.indexOf(".");
				if (cp != -1) {
					pfname = pfname.substring(0, cp - 1);
				}
				pfname = pfname.substring(0, 8);
			}
			if(!f.exists()&&!f.isFile()){
				System.err.println("̓t@Cw肵ĂB");
				return;
			}
			is = new FileInputStream(f);
			isr = new InputStreamReader(is);
			br = new BufferedReader(isr);
			
			baos = new ByteArrayOutputStream();
			bos = new BufferedOutputStream(baos);
			int ch = br.read();
			String t = wideTxt;
			while (ch != -1) {
				int h2k = hiragana.indexOf(ch);
				if (h2k != -1) {
					// J^Jiɕϊ
					ch = katakana.charAt(h2k);
				} else {
					int ac = ascii.indexOf(ch);
					if (ac != -1) {
						// ppLSpɕϊ
						ch = t.charAt(ac + 32);
					}
				}
				int wc = t.indexOf(ch);
				if (ch == 13) {
					// s͂̂܂0x0do
					bos.write(13);
//					System.err.print((char)13);
					ch = br.read();
				} else {
					if (wc < 0) {
						// _/_tJiΉ
						int wc2 = voiceConsonantKana.indexOf(ch);
						if (wc2 != -1){
							wc = t.indexOf(voiceConsonantKanaTxt.substring(wc2 * 2, wc2 * 2 + 1));
							bos.write(wc);
							wc = t.indexOf(voiceConsonantKanaTxt.substring(wc2 * 2 + 1, wc2 * 2 + 2));
						}
					} else if (ch == 10) {
						// Ver.2.0 ΍
						System.err.print("WARN:gpĂ܂B(Ver.2.0ł͉sɉ܂B");
					}
					bos.write(wc);
//					System.err.print((char)wc);
				}
				ch = br.read();
			}
			bos.flush();
			int codeLen = baos.toByteArray().length;
			int dataLen = 24 + codeLen;
			if ((codeLen + 12) % 16 != 0) {
				int padLen = (16 - (codeLen + 12) % 16);
				dataLen = dataLen + padLen;
//				System.out.println(dataLen);
				for (int i = 0; i < padLen; i++) {
					bos.write(0);
				}
				bos.flush();
			}
			
			byte[] codeBytes = baos.toByteArray();
			
			bos.close();
			baos.close();
			
			fos = new FileOutputStream(outFile);
			bos = new BufferedOutputStream(fos);
			
			bos.write("PX01".getBytes(), 0, 4);
			int dataLen2 = dataLen;
			for (int i = 0; i < 4; i++) {
				int b = dataLen2 % 256;
				dataLen2 = dataLen2 / 256;
				bos.write(b);
			}
			for (int i = 0; i < 4; i++) {
				bos.write(0);
			}
			bos.write(pfname.getBytes(), 0, pfname.getBytes().length);
			for (int i = 0; i < 8 - pfname.getBytes().length; i++) {
				bos.write(0);
			}
			
			baos = new ByteArrayOutputStream(dataLen);
			baos.write("PETC0300RPRG".getBytes(), 0, 12);
			for (int i = 0; i < 4; i++) {
				baos.write(0);
			}
			for (int i = 0; i < 4; i++) {
				baos.write(0);
			}
			int codeLen2 = codeLen;
			for (int i = 0; i < 4; i++) {
				int b = codeLen2 % 256;
				codeLen2 = codeLen2 / 256;
				baos.write(b);
			}
			baos.write(codeBytes, 0, codeBytes.length);
			byte[] mb = baos.toByteArray();
			MessageDigest md = MessageDigest.getInstance("MD5");
			md.update("PETITCOM".getBytes());
			md.update(mb);
			byte[] dig = md.digest();
			for(int i = 0; i < dig.length; i++) {
				int a = dig[i];
				if (a < 0) { a = a + 256; }
//				System.out.print(Integer.toString(a, 16) + " ");
				bos.write(a);
			}
			bos.write(mb, 0, mb.length);
// (vÕoCg+12)%16
// 00f[^MD5łA
// ۂ̃f[^00B(t@CTCYK16̔{ƂȂ)
		} catch (IOException e) {
			e.printStackTrace();
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		} finally {
			try {
				if(br != null){
					br.close();
				}
			} catch (IOException e) {
			}
			try {
				if(isr != null){
					isr.close();
				}
			} catch (IOException e) {
			}
			try {
				if(is != null){
					is.close();
				}
			} catch (IOException e) {
			}
			try {
				if(bos != null){
					bos.close();
				}
			} catch (IOException e) {
			}
			try {
				if(baos != null){
					baos.close();
				}
			} catch (IOException e) {
			}
			try {
				if(fos != null){
					fos.close();
				}
			} catch (IOException e) {
			}
		}
	}
}